题目描述
幻想乡的纵切面可以抽象成一个 n\times mn×m 的矩形。
其中每一个 1×1 的单元格(i,j) 都有一个电阻计量值(虚构的概念) R_{i,j}R
i,j
闪电从雷雨云上的O(n,a) 发出,击中了地面上的红魔馆A(1,b) 与迷途竹林 B(1,c)。
雷电是自然的造物,所以覆盖的位置电阻计量值总和最小,即从O 到 A 与 B 的两条路径的并集的电阻计量值的和最小。
所以在所有位置电阻计量已知的情况下,Cirno 想知道雷电的经过的路径的最小电阻计量值的和。
题目分析
不难看出此题考察的是最短路的知识,但分求两条路径会有重复的边。我们可以对三个询问点分别求出每个点到其的最短路,枚举重合点即可
code
#include<bits/stdc++.h>
using namespace std;
const int N = 1010, M = 2 * N;
typedef long long ll;
typedef pair<ll, pair<int, int>>PII;
const ll INF = 1ll << 60;
int n, m, k, t, A, B, C;
ll dist[3][N][N], g[N][N];
bool st[N][N];
int dx[4] = {0, 1, 0, -1}, dy[4] = {1, 0, -1, 0};
void dijkstra(int sx, int sy, int cnt)
{
memset(st, 0, sizeof st);
memset(dist[cnt], 0x3f, sizeof dist[cnt]);
dist[cnt][sx][sy] = g[sx][sy];
priority_queue<PII, vector<PII>, greater<PII>>q;
q.push({0, {sx, sy}});
while(q.size())
{
auto t = q.top();
q.pop();
int nx = t.second.first, ny = t.second.second;
if(st[nx][ny]) continue;
st[nx][ny] = true;
for(int i = 0; i < 4; i ++)
{
int xx = dx[i] + nx, yy = dy[i] + ny;
if(xx < 1 || xx > n || yy < 1 || yy > n) continue;
if(st[xx][yy]) continue;
if(dist[cnt][xx][yy] > dist[cnt][nx][ny] + g[xx][yy])
{
dist[cnt][xx][yy] = dist[cnt][nx][ny] + g[xx][yy];
q.push({dist[cnt][xx][yy], {xx, yy}});
}
}
}
}
int main()
{
cin >> n >> m >> A >> B >> C;
for(int i = 1; i <= n; i ++)
for(int j = 1; j <= m; j++)
cin >> g[i][j];
dijkstra(1, A, 0);
dijkstra(n, B, 1);
dijkstra(n, C, 2);
ll ans = 1ll << 60;
for(int i = 1; i <= n; i ++)
for(int j = 1; j <= m; j ++)
{
ll res = dist[0][i][j] + dist[1][i][j] + dist[2][i][j] - 2 * g[i][j];
ans = min(ans, res);
//cout << "--" << dist[0][i][j] << "--" << "\n";
}
cout << ans << "\n";
return 0;
}
总结
此题用到了三维的dist
数组,也用到了一种新的求最短路的思路